/*
Copyright The Clusternet Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/
// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v1beta1 "github.com/clusternet/clusternet/pkg/apis/clusters/v1beta1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeManagedClusters implements ManagedClusterInterface
type FakeManagedClusters struct {
	Fake *FakeClustersV1beta1
	ns   string
}

var managedclustersResource = schema.GroupVersionResource{Group: "clusters.clusternet.io", Version: "v1beta1", Resource: "managedclusters"}

var managedclustersKind = schema.GroupVersionKind{Group: "clusters.clusternet.io", Version: "v1beta1", Kind: "ManagedCluster"}

// Get takes name of the managedCluster, and returns the corresponding managedCluster object, and an error if there is any.
func (c *FakeManagedClusters) Get(ctx context.Context, name string, options v1.GetOptions) (result *v1beta1.ManagedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(managedclustersResource, c.ns, name), &v1beta1.ManagedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedCluster), err
}

// List takes label and field selectors, and returns the list of ManagedClusters that match those selectors.
func (c *FakeManagedClusters) List(ctx context.Context, opts v1.ListOptions) (result *v1beta1.ManagedClusterList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(managedclustersResource, managedclustersKind, c.ns, opts), &v1beta1.ManagedClusterList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v1beta1.ManagedClusterList{ListMeta: obj.(*v1beta1.ManagedClusterList).ListMeta}
	for _, item := range obj.(*v1beta1.ManagedClusterList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested managedClusters.
func (c *FakeManagedClusters) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(managedclustersResource, c.ns, opts))

}

// Create takes the representation of a managedCluster and creates it.  Returns the server's representation of the managedCluster, and an error, if there is any.
func (c *FakeManagedClusters) Create(ctx context.Context, managedCluster *v1beta1.ManagedCluster, opts v1.CreateOptions) (result *v1beta1.ManagedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(managedclustersResource, c.ns, managedCluster), &v1beta1.ManagedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedCluster), err
}

// Update takes the representation of a managedCluster and updates it. Returns the server's representation of the managedCluster, and an error, if there is any.
func (c *FakeManagedClusters) Update(ctx context.Context, managedCluster *v1beta1.ManagedCluster, opts v1.UpdateOptions) (result *v1beta1.ManagedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(managedclustersResource, c.ns, managedCluster), &v1beta1.ManagedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedCluster), err
}

// UpdateStatus was generated because the type contains a Status member.
// Add a +genclient:noStatus comment above the type to avoid generating UpdateStatus().
func (c *FakeManagedClusters) UpdateStatus(ctx context.Context, managedCluster *v1beta1.ManagedCluster, opts v1.UpdateOptions) (*v1beta1.ManagedCluster, error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateSubresourceAction(managedclustersResource, "status", c.ns, managedCluster), &v1beta1.ManagedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedCluster), err
}

// Delete takes name of the managedCluster and deletes it. Returns an error if one occurs.
func (c *FakeManagedClusters) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(managedclustersResource, c.ns, name, opts), &v1beta1.ManagedCluster{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeManagedClusters) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(managedclustersResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v1beta1.ManagedClusterList{})
	return err
}

// Patch applies the patch and returns the patched managedCluster.
func (c *FakeManagedClusters) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v1beta1.ManagedCluster, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(managedclustersResource, c.ns, name, pt, data, subresources...), &v1beta1.ManagedCluster{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v1beta1.ManagedCluster), err
}
